@use './variables' as *;
@use '@gouvfr/dsfr/src/dsfr/core/index' as dsfr;
@use '@gouvfr/dsfr/src/module/media-query' as dsfr-media-query;

:root {
  --primary-light: #{$primary-light};
  --primary-light-hover: #{$primary-light-hover};
  --primary: #{$primary};
  --primary-hover: #{$primary-hover};
  --primary-active: #{$primary-active};
  --rust: #{$rust};
  --rust-light: #{$rust-light};
  --deep-blue: #{$deep-blue};

  /* Typo */
  --bold: #{$font-weight-bold};

  /* Default values */
  --default-border-radius: #{$default-border-radius};

  /* DSFR customisation */
  --background-action-high-blue-france: #{$primary};
  --border-action-high-blue-france: #{$primary};
  --text-action-high-blue-france: #{$primary};

  /* Couleurs theme rubriques */
  --color-followup-light: #{$followup-light};
  --color-followup-light-hover: #{$followup-light-hover};
  --color-followup: var(--green-archipel-sun-391-moon-716);
  --color-followup-hover: var(--green-archipel-sun-391-moon-716-hover);
  --color-followup-active: var(--green-archipel-sun-391-moon-716);
  --color-help-request-light: #{$help-request-light};
  --color-help-request-light-hover: #{$help-request-light-hover};
  --color-help-request: var(--purple-glycine-main-494);

  /* FIXME: forced to use CSS variable, --purple-glycine-main-494-hover not working */
  --color-help-request-hover: #{$help-request-hover};
  --color-help-request-active: var(--purple-glycine-main-494);
  --color-mes-droits-sociaux: var(--blue-cumulus-sun-368-moon-732);
  --color-mes-droits-sociaux-hover: var(--blue-cumulus-sun-368-moon-732);
  --color-mes-droits-sociaux-active: var(--blue-cumulus-sun-368-moon-732);
}

html,
body,
#__nuxt {
  height: 100%;
}

nav.content,
main.content {
  height: calc(100vh - #{$actions-bar-height} - #{$top-bar-height});
  overflow-y: auto;
}

.main-container {
  background-color: #fff;
  border-radius: 1rem;
  box-shadow: $shadow-light;
}

.bg-color-white {
  background-color: white;
}

.color-red {
  color: var(--text-default-error);
}

.show-scrollbar {
  /* stylelint-disable property-no-vendor-prefix */
  &::-webkit-scrollbar {
    -webkit-appearance: none;
  }

  &::-webkit-scrollbar:vertical {
    width: 11px;
  }

  &::-webkit-scrollbar:horizontal {
    height: 11px;
  }

  &::-webkit-scrollbar-thumb {
    border-radius: 8px;
    border: 2px solid #fff;
    background-color: rgba(0 0 0 / 50%);
  }
}

.table-container {
  overflow-x: auto;

  &::-webkit-scrollbar {
    -webkit-appearance: none;
  }

  &::-webkit-scrollbar:vertical {
    width: 11px;
  }

  &::-webkit-scrollbar:horizontal {
    height: 11px;
  }

  &::-webkit-scrollbar-thumb {
    border-radius: 8px;
    border: 2px solid #fff;
    background-color: rgba(0 0 0 / 50%);
  }

  .fr-table {
    &:not(.fr-table--no-scroll, .fr-table--avoid-scroll) {
      width: max-content;
      min-width: 100%;
    }

    table {
      display: table;
    }

    tbody {
      background-color: white;

      tr .fr-badge {
        width: max-content;
      }
    }

    thead,
    &:not(.stripped-table) tbody {
      background-color: white;
    }

    .clickable-row {
      cursor: pointer;
      position: relative;

      &:hover {
        background-color: var(--background-default-grey-hover);
      }

      &:active {
        background-color: var(--background-default-grey-active);
      }
    }
  }
}

.results-container {
  display: flex;
  justify-content: space-between;
  align-items: center;
  flex-wrap: wrap;

  .results-count {
    margin-top: auto;
    margin-bottom: auto;
  }
}

.information-list {
  @include dsfr.disable-list-style;

  --li-bottom: 0.5rem;

  .information-label {
    font-weight: 700;
  }

  .information-line {
    display: block;
  }
}

.feature-section {
  border-radius: 0.5rem;
  border: 1px solid var(--border-default-grey);
  background-color: var(--background-default-grey);
  padding: 1.5rem;

  .fr-container {
    padding: 0;
  }

  &.fr-accordion {
    padding: 0;
  }
}

@keyframes rotation {
  0% {
    transform: rotate(0deg);
  }

  100% {
    transform: rotate(360deg);
  }
}

@keyframes slide-down {
  0% {
    opacity: 0;
    transform: translateY(-1.6rem);
  }

  100% {
    opacity: 1;
    transform: translateY(0);
  }
}

// FIXME: DSFR v1.8.* regression - See https://github.com/GouvernementFR/dsfr/issues/488
@include dsfr-media-query.respond-from('md') {
  .fr-container--fluid {
    overflow: initial;
  }
}

// It seems incredibly horrible but is necessary to be able to override DSFR when programmatically focusing an element
.force-focus-visible:focus:not(:focus-visible),
input:focus:not(:focus-visible),
select:focus:not(:focus-visible) {
  outline-style: solid !important;
}

.landing-subtitle {
  display: block;
  font-weight: normal;
  text-align: center;

  @include dsfr.title-style(h5);
}

.landing-video {
  background: none !important;

  &:hover,
  &:focus,
  &:active {
    background: none !important;
  }

  &::after {
    display: none;
  }
}

.social-support-subjects-data > span {
  overflow: hidden;
  display: -webkit-box;
  -webkit-line-clamp: 3; /* number of lines to show */
  line-clamp: 3;
  -webkit-box-orient: vertical;
}

.bg-color-grey-light {
  background-color: var(--background-contrast-grey);
}

.br-16 {
  border-radius: 16px;
}

.title-blue {
  color: var(--primary);
}

.landing-main-container {
  flex: 1 1 auto;
  padding-inline: 0.5rem;

  @include dsfr-media-query.respond-from('lg') {
    padding-inline: 1rem;
  }
}

.fr-link {
  &.underline {
    text-decoration: underline;
    text-decoration-thickness: 1px;
    text-underline-offset: 0.25rem;
  }

  &:hover {
    background-color: transparent;
    text-decoration-thickness: 2px;
  }
}

.fr-accordion::before {
  box-shadow: none;
}

.fr-accordion__btn::after {
  --icon-size: 1.5rem;
}

.fr-artwork .fr-artwork-major {
  --artwork-major-blue-france: var(--primary);
}

.fr-container.fr-container--no-max {
  max-width: initial;
}

.table-row-link {
  --underline-img: none;

  &:focus-visible,
  &:focus {
    outline-width: 0;
  }

  // Make the whole table role clickable to navigate on the cell link
  &::before {
    content: '';
    display: block;
    position: absolute;
    inset: 0;
    width: 100%;
    height: 100%;
    outline-offset: 2px;
    outline-style: inherit;
    outline-color: inherit;
    outline-width: 2px;
  }
}

.euro-symbol::after {
  content: '\00a0€';
}

.text--grey {
  color: var(--text-default-grey);
}

.text--muted {
  color: var(--grey-425-625);
}

.btn-container,
.btn-container--right,
.btn-container--left {
  display: flex;
  flex-direction: row;
  gap: 0.75rem;
  align-items: flex-end;
}

.btn-container--right {
  justify-content: flex-end;
}

.btn-container--left {
  justify-content: flex-start;
}
